﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Terraria;
using Terraria.GameContent.UI.Elements;
using Terraria.ModLoader;
using Terraria.UI;

namespace Test.UI
{
    public class ExampleUI : UIState
    {
        public static bool Visible = false;
        private ProgressBar bar;
        public override void OnInitialize()
        {
            //实例化一个面板
            UIPanel panel = new UIPanel();
            //设置面板的宽度
            panel.Width.Set(488f, 0f);
            //设置面板的高度
            panel.Height.Set(568f, 0f);
            //设置面板距离屏幕最左边的距离
            panel.Left.Set(-244f, 0.5f);
            //设置面板距离屏幕最上端的距离
            panel.Top.Set(-284f, 0.5f);
            //将这个面板注册到UIState
            Append(panel);

            //用tr原版图片实例化一个图片按钮
            UIImageButton button = new UIImageButton(ModContent.GetTexture("Terraria/UI/ButtonPlay"));
            //设置按钮距宽度
            button.Width.Set(22f, 0f);
            //设置按钮高度
            button.Height.Set(22f, 0f);
            //设置按钮距离所属ui部件的最左端的距离
            button.Left.Set(-11f, 0.5f);
            //设置按钮距离所属ui部件的最顶端的距离
            button.Top.Set(-11f, 0.5f);
            //注册一个事件，这个事件将会在按钮按下时被激活
            button.OnClick += Button_OnClick;
            //将按钮注册入面板中，这个按钮的坐标将以面板的坐标为基础计算
            panel.Append(button);

            //用tr原版图片实例化一个图片按钮
            UIImageButton closeButton = new UIImageButton(ModContent.GetTexture("Terraria/UI/ButtonDelete"));
            //设置按钮距宽度
            closeButton.Width.Set(22f, 0f);
            //设置按钮高度
            closeButton.Height.Set(22f, 0f);
            //设置按钮距离所属ui部件的最左端的距离
            closeButton.Left.Set(-22f, 1f);
            //设置按钮距离所属ui部件的最顶端的距离
            closeButton.Top.Set(0f, 0f);
            //注册一个事件，这个事件将会在按钮按下时被激活
            closeButton.OnClick += CloseButton_OnClick;
            //将按钮注册入面板中，这个按钮的坐标将以面板的坐标为基础计算
            panel.Append(closeButton);

            //用玩家的最大血量和玩家的现有血量实例化进度条
            bar = new ProgressBar(Main.LocalPlayer.statLifeMax2, Main.LocalPlayer.statLife);
            //设置进度条宽度
            bar.Width.Set(100f, 0f);
            //设置进度条高度
            bar.Height.Set(30f, 0f);
            //设置进度条距离所属ui部件的最左端的距离
            bar.Left.Set(20f, 0f);
            //设置进度条距离所属ui部件的最顶端的距离
            bar.Top.Set(20f, 0f);
            //将进度条注册入面板中，这个按钮的坐标将以面板的坐标为基础计算
            panel.Append(bar);

            base.OnInitialize();
        }
        public override void Draw(SpriteBatch spriteBatch)
        {
            //调用SetValue方法更新进度条的值
            bar.SetValue(Main.LocalPlayer.statLifeMax2, Main.LocalPlayer.statLife);
            base.Draw(spriteBatch);
        }
        private void CloseButton_OnClick(UIMouseEvent evt, UIElement listeningElement)
        {
            Visible = false;
        }

        private void Button_OnClick(UIMouseEvent evt, UIElement listeningElement)
        {
            Main.NewText("你按下了一个按钮！");
        }
    }
}
