﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Terraria;
using Terraria.GameContent.UI.Elements;
using Terraria.ModLoader;
using Terraria.UI;

namespace Test.UI
{
    class ProgressBar : UIElement
    {
        private float _maxValue, _value;
        //设置构造进度条要输入maxValue和value参数
        public ProgressBar(int maxValue, int value)
        {
            //为_maxValue赋值
            _maxValue = maxValue;
            //为_value赋值
            _value = value;
        }
        //重写绘制方法
        public override void Draw(SpriteBatch spriteBatch)
        {
            //创建一个局部变量，变量的值为ui左上角坐标
            Vector2 position = new Vector2(GetInnerDimensions().X, GetInnerDimensions().Y);
            //创建一个局部变量，变量的值为进度百分比
            float progress = _value / _maxValue;
            //绘制外边框
            spriteBatch.Draw(ModContent.GetTexture("Test/UI/Images/box"), new Rectangle((int)position.X, (int)position.Y, 100, 30), Color.White);
            //绘制表示内容的条，96 * progress是为了计算百分比宽度
            spriteBatch.Draw(ModContent.GetTexture("Test/UI/Images/bar"), new Rectangle((int)(position.X + 2), (int)(position.Y + 2), (int)(96 * progress), 26), Color.White);
            base.Draw(spriteBatch);
        }
        //调用方法要输入maxValue和value参数
        public void SetValue(int maxValue, int value)
        {
            //为_maxValue赋值
            _maxValue = maxValue;
            //为_value赋值
            _value = value;
        }
    }
}
